
<template>
  <div>
    <h1 class="centralizado">{{ title }}</h1>
    <input type="search" class="filter" v-on:input="filter = $event.target.value" placeholder="buscar" />
    {{filter}}
    <ul class="lista-fotos">
      <li class="lista-fotos-item" v-for="photo of filteredPhotos" v-bind:key="photo.title">
        <my-panel :title="photo.titulo">
          <my-img :src="photo.url" :alt="photo.titulo" />
          <my-button tipo="button" rotulo="Remover" @buttonClicked="remove($event,photo)" :confirmation="false"></my-button>
        </my-panel>
      </li>
    </ul>
  </div>
</template>

<script>
import Panel from "../shared/panel/Panel";
import Image from "../shared/image/Image";
import Button from "../shared/Button/Button";

export default {
  components: {
    "my-panel": Panel,
    "my-img": Image,
    "my-button":Button
  },
  data() {
    return {
      title: "testes",
      photos: [],
      filter: ""
    };
  },
  computed: {
    filteredPhotos(){
      if (this.filter) {
        let exp = new RegExp(this.filter.trim(), 'i');
        return this.photos.filter(photo => exp.test(photo.titulo));
      } else {
        // se o campo estiver vazio, não filtramos, retornamos a lista
        return this.photos;
      }
    }
  },methods:{
    remove($event,foto){
      alert($event)
      alert("remove"+foto.titulo)
    }
  },
  created() {
    //alert("worked");
    let url = "http://localhost:3000/v1/fotos";
    //let promise = this.$http.get(url);
    /*promise.then(res => {
      res.json().then(fotos => this.photos = fotos);
    });*/

    this.$http
      .get(url)
      .then(res => res.json())
      .then(fotos => (this.photos = fotos), err => console.log());
  }
};
</script>

<style lang="scss" scoped>
.centralizado {
  text-align: center;
}


.lista-fotos {
  list-style: none;
}

.lista-fotos .lista-fotos-item {
  display: inline-block;
  width: 200px;
}

.filter {
  display: block;
  width: 100%;
}
</style>
